Upgrade Agents

Cortex XSIAM Platform APIs

post /public_api/v1/endpoints/upgrade

Creates an upgrade action for the specified endpoints to upgrade their agents to the target versions.

You can specify target versions per operating system and optionally define a timeframe window for the upgrade.

Required license: Cortex XSIAM Premium, or any Cortex XSIAM product with the Cloud Runtime Security or Cloud Posture Security add-ons.

Request headers
Authorization String required

{api_key}

Example: authorization_example
x-xdr-auth-id String required

{api_key_id}

Example: xXdrAuthId_example
CLIENT REQUEST
curl -X 'POST'
-H 'Accept: application/json'
-H 'Content-Type: application/json'
-H 'Authorization: authorization_example' -H 'x-xdr-auth-id: xXdrAuthId_example'
'https://api-yourfqdn/public_api/v1/endpoints/upgrade'
-d ''
import http.client conn = http.client.HTTPSConnection("api-yourfqdn") payload = "{\"request_data\":{\"endpoint_ids\":[\"string\"],\"target_versions\":{\"property1\":\"string\",\"property2\":\"string\"},\"upgrade_timeframe_window\":{\"upgrade_timeframe_days\":[\"string\"],\"upgrade_timeframe_start_time\":\"string\",\"upgrade_timeframe_end_time\":\"string\"}}}" headers = { 'Authorization': "SOME_STRING_VALUE", 'x-xdr-auth-id': "SOME_STRING_VALUE", 'content-type': "application/json" } conn.request("POST", "/public_api/v1/endpoints/upgrade", payload, headers) res = conn.getresponse() data = res.read() print(data.decode("utf-8"))
require 'uri' require 'net/http' require 'openssl' url = URI("https://api-yourfqdn/public_api/v1/endpoints/upgrade") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true http.verify_mode = OpenSSL::SSL::VERIFY_NONE request = Net::HTTP::Post.new(url) request["Authorization"] = 'SOME_STRING_VALUE' request["x-xdr-auth-id"] = 'SOME_STRING_VALUE' request["content-type"] = 'application/json' request.body = "{\"request_data\":{\"endpoint_ids\":[\"string\"],\"target_versions\":{\"property1\":\"string\",\"property2\":\"string\"},\"upgrade_timeframe_window\":{\"upgrade_timeframe_days\":[\"string\"],\"upgrade_timeframe_start_time\":\"string\",\"upgrade_timeframe_end_time\":\"string\"}}}" response = http.request(request) puts response.read_body
const data = JSON.stringify({ "request_data": { "endpoint_ids": [ "string" ], "target_versions": { "property1": "string", "property2": "string" }, "upgrade_timeframe_window": { "upgrade_timeframe_days": [ "string" ], "upgrade_timeframe_start_time": "string", "upgrade_timeframe_end_time": "string" } } }); const xhr = new XMLHttpRequest(); xhr.withCredentials = true; xhr.addEventListener("readystatechange", function () { if (this.readyState === this.DONE) { console.log(this.responseText); } }); xhr.open("POST", "https://api-yourfqdn/public_api/v1/endpoints/upgrade"); xhr.setRequestHeader("Authorization", "SOME_STRING_VALUE"); xhr.setRequestHeader("x-xdr-auth-id", "SOME_STRING_VALUE"); xhr.setRequestHeader("content-type", "application/json"); xhr.send(data);
HttpResponse<String> response = Unirest.post("https://api-yourfqdn/public_api/v1/endpoints/upgrade") .header("Authorization", "SOME_STRING_VALUE") .header("x-xdr-auth-id", "SOME_STRING_VALUE") .header("content-type", "application/json") .body("{\"request_data\":{\"endpoint_ids\":[\"string\"],\"target_versions\":{\"property1\":\"string\",\"property2\":\"string\"},\"upgrade_timeframe_window\":{\"upgrade_timeframe_days\":[\"string\"],\"upgrade_timeframe_start_time\":\"string\",\"upgrade_timeframe_end_time\":\"string\"}}}") .asString();
import Foundation let headers = [ "Authorization": "SOME_STRING_VALUE", "x-xdr-auth-id": "SOME_STRING_VALUE", "content-type": "application/json" ] let parameters = ["request_data": [ "endpoint_ids": ["string"], "target_versions": [ "property1": "string", "property2": "string" ], "upgrade_timeframe_window": [ "upgrade_timeframe_days": ["string"], "upgrade_timeframe_start_time": "string", "upgrade_timeframe_end_time": "string" ] ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api-yourfqdn/public_api/v1/endpoints/upgrade")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume()
<?php $curl = curl_init(); curl_setopt_array($curl, [ CURLOPT_URL => "https://api-yourfqdn/public_api/v1/endpoints/upgrade", CURLOPT_RETURNTRANSFER => true, CURLOPT_ENCODING => "", CURLOPT_MAXREDIRS => 10, CURLOPT_TIMEOUT => 30, CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1, CURLOPT_CUSTOMREQUEST => "POST", CURLOPT_POSTFIELDS => "{\"request_data\":{\"endpoint_ids\":[\"string\"],\"target_versions\":{\"property1\":\"string\",\"property2\":\"string\"},\"upgrade_timeframe_window\":{\"upgrade_timeframe_days\":[\"string\"],\"upgrade_timeframe_start_time\":\"string\",\"upgrade_timeframe_end_time\":\"string\"}}}", CURLOPT_HTTPHEADER => [ "Authorization: SOME_STRING_VALUE", "content-type: application/json", "x-xdr-auth-id: SOME_STRING_VALUE" ], ]); $response = curl_exec($curl); $err = curl_error($curl); curl_close($curl); if ($err) { echo "cURL Error #:" . $err; } else { echo $response; }
CURL *hnd = curl_easy_init(); curl_easy_setopt(hnd, CURLOPT_CUSTOMREQUEST, "POST"); curl_easy_setopt(hnd, CURLOPT_URL, "https://api-yourfqdn/public_api/v1/endpoints/upgrade"); struct curl_slist *headers = NULL; headers = curl_slist_append(headers, "Authorization: SOME_STRING_VALUE"); headers = curl_slist_append(headers, "x-xdr-auth-id: SOME_STRING_VALUE"); headers = curl_slist_append(headers, "content-type: application/json"); curl_easy_setopt(hnd, CURLOPT_HTTPHEADER, headers); curl_easy_setopt(hnd, CURLOPT_POSTFIELDS, "{\"request_data\":{\"endpoint_ids\":[\"string\"],\"target_versions\":{\"property1\":\"string\",\"property2\":\"string\"},\"upgrade_timeframe_window\":{\"upgrade_timeframe_days\":[\"string\"],\"upgrade_timeframe_start_time\":\"string\",\"upgrade_timeframe_end_time\":\"string\"}}}"); CURLcode ret = curl_easy_perform(hnd);
var client = new RestClient("https://api-yourfqdn/public_api/v1/endpoints/upgrade"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "SOME_STRING_VALUE"); request.AddHeader("x-xdr-auth-id", "SOME_STRING_VALUE"); request.AddHeader("content-type", "application/json"); request.AddParameter("application/json", "{\"request_data\":{\"endpoint_ids\":[\"string\"],\"target_versions\":{\"property1\":\"string\",\"property2\":\"string\"},\"upgrade_timeframe_window\":{\"upgrade_timeframe_days\":[\"string\"],\"upgrade_timeframe_start_time\":\"string\",\"upgrade_timeframe_end_time\":\"string\"}}}", ParameterType.RequestBody); IRestResponse response = client.Execute(request);
Body parameters
application/json
request_dataobject

A dictionary containing the API request fields.

endpoint_idsarray[string]required

List of endpoint IDs to upgrade.

target_versionsobjectrequired

Dictionary mapping OS types to target agent versions. Valid keys: windows, linux, macos.

Additional propertiesstring
upgrade_timeframe_windowobject

Optional timeframe window to schedule the upgrade.

upgrade_timeframe_daysarray[string]

Days of the week for the upgrade timeframe (for example, Monday, Wednesday).

upgrade_timeframe_start_timestring

Start time in 24-hour HH:MM format.

upgrade_timeframe_end_timestring

End time in 24-hour HH:MM format.

REQUEST
{ "request_data": { "endpoint_ids": [ "endpoint_id_1", "endpoint_id_2" ], "target_versions": { "windows": "8.6.0.1234", "linux": "8.6.0.5678" } } }
{ "request_data": { "endpoint_ids": [ "endpoint_id_1" ], "target_versions": { "windows": "8.6.0.1234", "macos": "8.6.0.9012" }, "upgrade_timeframe_window": { "upgrade_timeframe_days": [ "monday", "wednesday", "friday" ], "upgrade_timeframe_start_time": "02:00", "upgrade_timeframe_end_time": "06:00" } } }
Responses

Successful response

Body
application/json
replyobject

JSON object containing the upgrade action result.

summarystring

A summary message of the operation result.

detailsarray[string]

Detailed eligibility or error messages per OS type.

RESPONSE
{ "reply": { "summary": "Upgrade action created successfully.", "details": [ "Windows: 2 endpoints queued for upgrade to 8.6.0.1234", "Linux: 1 endpoint queued for upgrade to 8.6.0.5678" ] } }

Bad Request. Got an invalid JSON.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Unauthorized access. An issue occurred during authentication. This can indicate an incorrect key, id, or other invalid authentication parameters.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Unauthorized access. User does not have the required license type to run this API.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Forbidden access. The provided API Key does not have the required RBAC permissions to run this API.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }

Internal server error. A unified status for API communication type errors.

Body
application/json

The query result upon error.

err_codestring

HTTP response code.

err_msgstring

Error message.

Example:"{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}"
err_extrastring

Additional information describing the error.

RESPONSE
{ "err_code": "example", "err_msg": "{\"line\": 1, \"column\": 19, \"message\": \"no viable alternative at input '|alter2'\"}", "err_extra": "example" }